from PyQt4.QtGui import *  
from PyQt4.QtCore import *  
from PyQt4.QtWebKit import *  
from lxml import html 
import lxml
from selenium import webdriver
import itertools
import time
import random
import os
import io

# Script for scraping all contact info from people.nasa.gov
# Stephen Reid McLaughlin
# PhD Student, UT Austin School of Information
# stephen.mclaughlin@utexas.edu

# Following same procedure as email search scrape, using last names instead.
# Our main objective is to find directory listings that do not include email addresses.

os.chdir(os.path.expanduser('~/Dropbox/DataRefuge/NASA_Directory/raw_pages_last_name'))

chars="abcdefghijklmnopqrstuvwxyz ',-1234567890"   # All characters used in name field (not case sensitive)

def js_to_html(url,driver):     # Function that renders a page, including JavaScript content, and returns its content as static html.
    driver.get(url)      # Loads page in headless browser
    return driver.page_source


#### Running scrape as a while loop


try_more_chars=[None]
stems="abcdefghijklmnopqrstuvwxyz ',-1234567890"

round=1

while len(try_more_chars)>0:
    print("\nRound "+str(round))
    round+=1
    driver = webdriver.PhantomJS()
    try_more_chars=[]
    longer_combos=[]
    for stem in stems:
        for char in chars:
            longer_combos.append(stem+char)
    longer_combos=[item for item in longer_combos if (item[0]!=' ')&('  ' not in item)]  # Because spaces at start and end of search term are ignored, without this step we'd end up in an infinite loop.
    for stem in longer_combos:
        url="https://people.nasa.gov/people/search?firstName=&middleInitial=&lastName=%s*&email=&phone="%stem
        page_html=js_to_html(url,driver)
        if "Size limit exceeded." in page_html:
            print("Size limit exceeded for "+stem)
            try_more_chars.append(stem)
        if '''<tr class="even">''' in page_html:
            filename=(stem+'.html')
            print(filename)
            with io.open(filename, 'w', encoding='utf-8') as fo:
                fo.write(page_html)
        time.sleep(0.1*random.random())
    print(try_more_chars)
    stems=try_more_chars

