from PyQt4.QtGui import *  
from PyQt4.QtCore import *  
from PyQt4.QtWebKit import *  
from lxml import html 
import lxml
from selenium import webdriver
import itertools
import time
import random
import os
import io

# Script for scraping all contact info from people.nasa.gov
# Stephen Reid McLaughlin
# PhD Student, UT Austin School of Information
# stephen.mclaughlin@utexas.edu

# Following same procedure as email search scrape, using first names instead.
# Our main objective is to find directory listings that do not include email addresses.

os.chdir(os.path.expanduser('~/Dropbox/DataRefuge/NASA_Directory/raw_pages_first_name'))

chars="abcdefghijklmnopqrstuvwxyz ',-1234567890"   # All characters used in name field.

def js_to_html(url,driver):     # Function that renders a page, including JavaScript content, and returns its content as static html.
    driver.get(url)      # Loads page in headless browser
    return driver.page_source


#### Running scrape as a while loop

try_more_chars=[None]
stems="abcdefghijklmnopqrstuvwxyz ',-1234567890"

round=1

while len(try_more_chars)>0:
    driver = webdriver.PhantomJS()
    try_more_chars=[]
    longer_combos=[]
    for stem in stems:
        for char in chars:
            longer_combos.append(stem+char)
    longer_combos=[item for item in longer_combos if (item[0]!=' ')&('  ' not in item)]
    for stem in longer_combos:
        url="https://people.nasa.gov/people/search?firstName=%s*&middleInitial=&lastName=&email=&phone="%stem
        page_html=js_to_html(url,driver)
        if "Size limit exceeded." in page_html:
            print("Size limit exceeded for "+stem)
            try_more_chars.append(stem)
        if '''<tr class="even">''' in page_html:
            filename=(stem+'.html')
            print(filename)
            with io.open(filename, 'w', encoding='utf-8') as fo:
                fo.write(page_html)
        time.sleep(0.1*random.random())
    print("\nRound "+str(round))
    round+=1
    print(try_more_chars)
    stems=try_more_chars



#### Additional steps to capture directory entries with >100 identical names


driver = webdriver.PhantomJS()

first_name="cneacc ctest"

chars="abcdefghijklmnopqrstuvwxyz ',-1234567890"

try_more_chars=[]

for char in chars:
    url="https://people.nasa.gov/people/search?firstName=%s&middleInitial=&lastName=&email=%s*&phone="%(first_name,char)
    page_html=js_to_html(url,driver)
    if "Size limit exceeded." in page_html:
        print("Size limit exceeded for "+char)
        try_more_chars.append(char)
    else:
        filename=(first_name+"__"+char+'.html')
        if '''<tr class="even">''' in page_html:
            print(filename)
            with io.open(filename, 'w', encoding='utf-8') as fo:
                fo.write(page_html)
    time.sleep(0.1*random.random())

print(try_more_chars)

# Still >100 results for "m", so let's try variations in their email addresses.

first_name="cneacc ctest"

try_more_chars=[]

for char in chars:
    url="https://people.nasa.gov/people/search?firstName=%s&middleInitial=&lastName=&email=%s*&phone="%(first_name,"msfc-"+char)
    page_html=js_to_html(url,driver)
    if "Size limit exceeded." in page_html:
        print("Size limit exceeded for "+char)
        try_more_chars.append(char)
    else:
        filename=(first_name+"__"+"msfc-"+char+'.html')
        if '''<tr class="even">''' in page_html:
            print(filename)
            with io.open(filename, 'w', encoding='utf-8') as fo:
                fo.write(page_html)
    time.sleep(0.1*random.random())

print(try_more_chars)

# Still >100 results for "i", so let's try more email address variations.

first_name="cneacc ctest"

try_more_chars=[]

for char in chars:
    url="https://people.nasa.gov/people/search?firstName=%s&middleInitial=&lastName=&email=%s*&phone="%(first_name,"msfc-iemp"+char)
    page_html=js_to_html(url,driver)
    if "Size limit exceeded." in page_html:
        print("Size limit exceeded for "+char)
        try_more_chars.append(char)
    else:
        filename=(first_name+"__"+"msfc-iemp__"+char+'.html')
        if '''<tr class="even">''' in page_html:
            print(filename)
            with io.open(filename, 'w', encoding='utf-8') as fo:
                fo.write(page_html)
    time.sleep(0.1*random.random())

print(try_more_chars)


# Success!


#### >100 entries named "Cperformance, Cneacc" have numbered email addresses in the following format: ccperf089@nodelivery.nasa.gov


chars="0123456789"
try_more_chars=[]

for char in chars:
    url="https://people.nasa.gov/people/search?firstName=&middleInitial=&lastName=&email=%s*&phone="%("ccperf"+char)
    page_html=js_to_html(url,driver)
    if "Size limit exceeded." in page_html:
        print("Size limit exceeded for "+char)
        try_more_chars.append(char)
    else:
        filename=('ccperf__'+char+'.html')
        if '''<tr class="even">''' in page_html:
            print(filename)
            with io.open(filename, 'w', encoding='utf-8') as fo:
                fo.write(page_html)
    time.sleep(0.1*random.random())

print(try_more_chars)

# ['2', '3', '4'] still return >100 results, so...

chars="0123456789"
try_more_chars=[]

for digit in ['2', '3', '4']:
    for char in chars:
        url="https://people.nasa.gov/people/search?firstName=&middleInitial=&lastName=&email=%s*&phone="%("ccperf"+digit+char)
        page_html=js_to_html(url,driver)
        if "Size limit exceeded." in page_html:
            print("Size limit exceeded for "+char)
            try_more_chars.append(char)
        else:
            filename=('ccperf__'+digit+char+'.html')
            if '''<tr class="even">''' in page_html:
                print(filename)
                with io.open(filename, 'w', encoding='utf-8') as fo:
                    fo.write(page_html)
        time.sleep(0.1*random.random())

print(try_more_chars)

# Success!












